## SignonAuthService SignonAuthService — The authorization service object |

## Functions

SignonAuthService * | signon_auth_service_new ()
void | signon_auth_service_get_mechanisms ()
gchar ** | signon_auth_service_get_mechanisms_finish ()
gchar ** | signon_auth_service_get_mechanisms_sync ()
void | signon_auth_service_get_methods ()
gchar ** | signon_auth_service_get_methods_finish ()
gchar ** | signon_auth_service_get_methods_sync ()

## Types and Values

struct | SignonAuthService

## Object Hierarchy

        GObject
        ╰── SignonAuthService

## Description

The SignonAuthService is the main object in this library.

## Functions

### signon_auth_service_new ()

    SignonAuthService *
    signon_auth_service_new ();

Create a new SignonAuthService.

#### Returns

an instance of an SignonAuthService.

### signon_auth_service_get_mechanisms ()

    void
    signon_auth_service_get_mechanisms (SignonAuthService *auth_service,
                                        const gchar *method,
                                        GCancellable *cancellable,
                                        GAsyncReadyCallback callback,
                                        gpointer user_data);

Lists all the available mechanisms.

#### Parameters

auth_service | a SignonAuthService |
method | the name of the method whose mechanisms must be retrieved. |
cancellable | a GCancellable or `NULL`. | [nullable]
callback | a callback to execute upon completion |
user_data | closure data for `callback` |

Since: 2.0

### signon_auth_service_get_mechanisms_finish ()

    gchar **
    signon_auth_service_get_mechanisms_finish
                                   (SignonAuthService *auth_service,
                                    GAsyncResult *result,
                                    GError **error);

Completes an asynchronous request to `signon_auth_service_get_mechanisms()`.

#### Parameters

auth_service | a SignonAuthService |
result | a GAsyncResult |
error | a location for a GError, or `NULL` |

#### Returns

A list of available mechanisms.

[array zero-terminated=1][transfer full]

### signon_auth_service_get_mechanisms_sync ()

    gchar **
    signon_auth_service_get_mechanisms_sync
                                   (SignonAuthService *auth_service,
                                    const gchar *method,
                                    GCancellable *cancellable,
                                    GError **error);

Lists all the available mechanisms. This is a blocking version of `signon_auth_service_get_mechanisms()`.

#### Parameters

auth_service | a SignonAuthService |
method | the name of the method whose mechanisms must be retrieved. |
cancellable | a GCancellable or `NULL`. | [nullable]
error | a location for a GError, or `NULL` |

#### Returns

A list of available mechanisms.

[array zero-terminated=1][transfer full]

Since: 2.0

### signon_auth_service_get_methods ()

    void
    signon_auth_service_get_methods (SignonAuthService *auth_service,
                                     GCancellable *cancellable,
                                     GAsyncReadyCallback callback,
                                     gpointer user_data);

Lists all the available methods.

#### Parameters

auth_service | a SignonAuthService |
cancellable | a GCancellable or `NULL`. | [nullable]
callback | a callback to execute upon completion |
user_data | closure data for `callback` |

Since: 2.0

### signon_auth_service_get_methods_finish ()

    gchar **
    signon_auth_service_get_methods_finish
                                   (SignonAuthService *auth_service,
                                    GAsyncResult *result,
                                    GError **error);

Completes an asynchronous request to `signon_auth_service_get_methods()`.

#### Parameters

auth_service | a SignonAuthService |
result | a GAsyncResult |
error | a location for a GError, or `NULL` |

#### Returns

A list of available methods.

[array zero-terminated=1][transfer full]

### signon_auth_service_get_methods_sync ()

    gchar **
    signon_auth_service_get_methods_sync (SignonAuthService *auth_service,
                                          GCancellable *cancellable,
                                          GError **error);

Lists all the available methods. This is a blocking version of `signon_auth_service_get_methods()`.

#### Parameters

auth_service | a SignonAuthService |
cancellable | a GCancellable or `NULL`. | [nullable]
error | a location for a GError, or `NULL` |

#### Returns

A list of available methods.

[array zero-terminated=1][transfer full]

Since: 2.0

## Types and Values

### struct SignonAuthService

    struct SignonAuthService;

Opaque struct. Use the accessor functions below.